package com.upay.sdk.config;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.ConfigurationUtils;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.onlinepay.builder.QueryBuilder;
import com.upay.sdk.onlinepay.executer.OnlinePayOrderExecuter;
import org.apache.commons.configuration.MapConfiguration;

import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;

/**
 * 功能描述: <br/>
 *
 * @author Administrator
 * @date: 2023-09-24 22:12<br/>
 * @date: 22:12<br/>
 * @since JDK 1.8
 */
public class CustomConfig {

    public static void main(String[] args) {

        //注入配置示例
        //当商户系统的配置文件没有部署在本地，如在nacos中配置，可通过此示例方法，把远程的配置信息注入到sdk中

        Map<String, String> map = new HashMap<>();
        map.put("http.content.type.v3", "application/vnd.5upay-v3.0+json");
        map.put("http.content.type.v4", "application/vnd.5upay-v4.0+json");
        map.put("890000593.client.private.key.path", "d:\\client.pfx");
        map.put("890000593.client.private.key.password", "123456");
        map.put("server.public.key.path", "d:\\server.cer");
        map.put("onlinepay.query.url", "https://apis.5upay.com/onlinePay/query");
        map.put("ehking.sdk.net.client.defaultConnectTimeout", "30000");
        map.put("ehking.sdk.net.client.defaultReadTimeout", "30000");
        //必须在sdk调用前初始化
        ConfigurationUtils.setConfigSource(new MapConfiguration(map));
        System.setProperty("jdk.tls.disabledAlgorithms", "");


        //收单查询测试代码
        String merchantId = "890000593";
        String requestId = "1695515483149";
        QueryBuilder builder = new QueryBuilder(merchantId);
        builder.setRequestId(requestId);
        final PrintStream out = System.out;
        OnlinePayOrderExecuter executer = new OnlinePayOrderExecuter();
        executer.bothQuery(builder, new ResultListenerAdpater() {
            @Override
            public void success(JSONObject jsonObject) {
                out.println("处理成功！<br/>");
                String result = jsonObject.toJSONString();
                out.print(result);
            }

            @Override
            public void failure(JSONObject jsonObject) {
                out.println("处理失败！<br/>");
                String result = jsonObject.toJSONString();
                out.print(result);
            }

            @Override
            public void pending(JSONObject jsonObject) {
                out.println("待处理！<br/>");
                String result = jsonObject.toJSONString();
                out.print(result);
            }
        });
    }
}